=== share/CMakeLists.txt ===
add_subdirectory(eckit)
