=== tests/CMakeLists.txt ===
add_subdirectory( config )
add_subdirectory( container )
add_subdirectory( exception )
add_subdirectory( filesystem )
add_subdirectory( geometry )
add_subdirectory( io )
add_subdirectory( large_file )
add_subdirectory( linalg )
add_subdirectory( log )
add_subdirectory( maths )
add_subdirectory( memory )
add_subdirectory( mpi )
add_subdirectory( option )
add_subdirectory( parser )
add_subdirectory( runtime )
add_subdirectory( serialisation )
add_subdirectory( system )
add_subdirectory( testing )
add_subdirectory( thread )
add_subdirectory( types )
add_subdirectory( utils )
add_subdirectory( value )

if( eckit_HAVE_ECKIT_SQL )
    add_subdirectory( sql )
endif()

if( eckit_HAVE_ECKIT_CODEC )
    add_subdirectory( codec )
endif()

if( eckit_HAVE_ECKIT_GEO )
    add_subdirectory( geo )
endif()

if( eckit_HAVE_EXPERIMENTAL )
    add_subdirectory( experimental )
endif()
