=== debian/changelog ===
eckit (1.32.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Nov 2025 07:17:16 +0000
