## eckit 1.32.4

=== debian/changelog ===
eckit (1.32.4-3) unstable; urgency=medium

  * Standards-Version: 4.7.3
  * Clean autogenerated setup.py. Closes: #1045001, #1049734
  * Drop Priority: optional from source in d/control per new policy
  * Don't use RADOS on loong64; not supported  there yet

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Jan 2026 08:40:36 +0000

eckit (1.32.4-2) unstable; urgency=medium

  * Build against fixed ecbuild. Closes: #1122052
  * Move d/copyright to DEP-5, licensrecon fixes
  * Close previously fixed bug. Closes: #1044845

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 07 Dec 2025 12:55:06 +0000

eckit (1.32.4-1) unstable; urgency=medium

  * New upstream release
  * d/gbp.conf: now use pristine-tar
  * d/watch: Move to version 4 format

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 15:54:54 +0000
