=== debian/changelog ===
eckit (1.33.0-1) unstable; urgency=medium

  * New upstream release
  * New shared lib libeckit_spec.so.0d
  * Add d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Feb 2026 06:58:49 +0000
